/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the StampCard type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &StampCard{}

// StampCard struct for StampCard
type StampCard struct {
	CampaignName string `json:"campaign_name"`
	Points int32 `json:"points"`
	RewardName string `json:"reward_name"`
	StampIconUrl *string `json:"stamp_icon_url,omitempty"`
	RewardIconUrl *string `json:"reward_icon_url,omitempty"`
}

// NewStampCard instantiates a new StampCard object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStampCard(campaignName string, points int32, rewardName string) *StampCard {
	this := StampCard{}
	this.CampaignName = campaignName
	this.Points = points
	this.RewardName = rewardName
	return &this
}

// NewStampCardWithDefaults instantiates a new StampCard object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStampCardWithDefaults() *StampCard {
	this := StampCard{}
	return &this
}

// GetCampaignName returns the CampaignName field value
func (o *StampCard) GetCampaignName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CampaignName
}

// GetCampaignNameOk returns a tuple with the CampaignName field value
// and a boolean to check if the value has been set.
func (o *StampCard) GetCampaignNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CampaignName, true
}

// SetCampaignName sets field value
func (o *StampCard) SetCampaignName(v string) {
	o.CampaignName = v
}

// GetPoints returns the Points field value
func (o *StampCard) GetPoints() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Points
}

// GetPointsOk returns a tuple with the Points field value
// and a boolean to check if the value has been set.
func (o *StampCard) GetPointsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Points, true
}

// SetPoints sets field value
func (o *StampCard) SetPoints(v int32) {
	o.Points = v
}

// GetRewardName returns the RewardName field value
func (o *StampCard) GetRewardName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.RewardName
}

// GetRewardNameOk returns a tuple with the RewardName field value
// and a boolean to check if the value has been set.
func (o *StampCard) GetRewardNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.RewardName, true
}

// SetRewardName sets field value
func (o *StampCard) SetRewardName(v string) {
	o.RewardName = v
}

// GetStampIconUrl returns the StampIconUrl field value if set, zero value otherwise.
func (o *StampCard) GetStampIconUrl() string {
	if o == nil || IsNil(o.StampIconUrl) {
		var ret string
		return ret
	}
	return *o.StampIconUrl
}

// GetStampIconUrlOk returns a tuple with the StampIconUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StampCard) GetStampIconUrlOk() (*string, bool) {
	if o == nil || IsNil(o.StampIconUrl) {
		return nil, false
	}
	return o.StampIconUrl, true
}

// HasStampIconUrl returns a boolean if a field has been set.
func (o *StampCard) HasStampIconUrl() bool {
	if o != nil && !IsNil(o.StampIconUrl) {
		return true
	}

	return false
}

// SetStampIconUrl gets a reference to the given string and assigns it to the StampIconUrl field.
func (o *StampCard) SetStampIconUrl(v string) {
	o.StampIconUrl = &v
}

// GetRewardIconUrl returns the RewardIconUrl field value if set, zero value otherwise.
func (o *StampCard) GetRewardIconUrl() string {
	if o == nil || IsNil(o.RewardIconUrl) {
		var ret string
		return ret
	}
	return *o.RewardIconUrl
}

// GetRewardIconUrlOk returns a tuple with the RewardIconUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StampCard) GetRewardIconUrlOk() (*string, bool) {
	if o == nil || IsNil(o.RewardIconUrl) {
		return nil, false
	}
	return o.RewardIconUrl, true
}

// HasRewardIconUrl returns a boolean if a field has been set.
func (o *StampCard) HasRewardIconUrl() bool {
	if o != nil && !IsNil(o.RewardIconUrl) {
		return true
	}

	return false
}

// SetRewardIconUrl gets a reference to the given string and assigns it to the RewardIconUrl field.
func (o *StampCard) SetRewardIconUrl(v string) {
	o.RewardIconUrl = &v
}

func (o StampCard) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o StampCard) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["campaign_name"] = o.CampaignName
	toSerialize["points"] = o.Points
	toSerialize["reward_name"] = o.RewardName
	if !IsNil(o.StampIconUrl) {
		toSerialize["stamp_icon_url"] = o.StampIconUrl
	}
	if !IsNil(o.RewardIconUrl) {
		toSerialize["reward_icon_url"] = o.RewardIconUrl
	}
	return toSerialize, nil
}

type NullableStampCard struct {
	value *StampCard
	isSet bool
}

func (v NullableStampCard) Get() *StampCard {
	return v.value
}

func (v *NullableStampCard) Set(val *StampCard) {
	v.value = val
	v.isSet = true
}

func (v NullableStampCard) IsSet() bool {
	return v.isSet
}

func (v *NullableStampCard) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStampCard(val *StampCard) *NullableStampCard {
	return &NullableStampCard{value: val, isSet: true}
}

func (v NullableStampCard) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStampCard) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


